<template>
  <v-pagination
    v-if="!isMobile"
    page-aria-label="Page"
    v-model="modelValue"
    :length="length"
    :total-visible="6"
    theme="primary"
    variant="text"
    class="!list-none px-4 pt-4"
    @update:model-value="update"
  >
    <template #prev="{ disabled }">
      <div
        class="flex flex-row justify-center items-center text-dark-grey gap-2 hover:bg-very-light-grey hover:text-fake-black select-none p-3 rounded"
        :class="disabled ? '!text-middle-grey bg-transparent cursor-default' : 'cursor-pointer'"
        @click="previous"
      >
        <div>
          <Icon
            icon="mdi-arrow-left"
            width="16"
            height="16"
          />
        </div>

        <span class="text-sm font-medium normal-case not-italic">{{ "Previous" }}</span>
      </div>
    </template>

    <template #item="{ isActive, page, key, props }">
      <div
        v-bind="props"
        class="flex items-center rounded justify-center h-10 w-10 p-3 text-dark-grey text-sm font-medium cursor-pointer hover:bg-very-light-grey active:bg-light-grey select-none hover:text-fake-black"
        :class="isActive ? 'text-fake-black bg-very-light-grey cursor-default active:bg-very-light-grey ' : null"
      >
        {{ page }}
      </div>
    </template>

    <template #next="{ disabled }">
      <div
        class="flex flex-row justify-center items-center text-dark-grey gap-2 hover:bg-very-light-grey hover:text-fake-black select-none p-3 rounded"
        :class="disabled ? '!text-middle-grey bg-transparent cursor-default' : 'cursor-pointer'"
        @click="next"
      >
        <span class="text-sm font-medium normal-case not-italic">{{ "Next" }}</span>

        <div>
          <Icon
            icon="mdi-arrow-right"
            width="16"
            height="16"
          />
        </div>
      </div>
    </template>
  </v-pagination>

  <div
    v-else
    class="flex w-full items-center justify-between"
  >
    <svn-icon-button
      icon="ic:baseline-arrow-back"
      button-size="sm"
      variant="plain"
      :disable="modelValue <= 1"
      @click="previous"
    />

    <div>Page {{ modelValue }} of {{ length }}</div>

    <svn-icon-button
      icon="ic:baseline-arrow-forward"
      button-size="sm"
      variant="plain"
      :disable="modelValue >= length"
      @click="next"
    />
  </div>
</template>

<script setup>
import { Icon } from "@iconify/vue";
import { onMounted, onUnmounted, ref, watch } from "vue";
import SvnIconButton from "../button/SvnIconButton.vue";

const props = defineProps({
  length: { type: Number, required: true, default: 1 },
  page: { type: Number, default: 1 },
})

const modelValue = ref(props?.page)

const emits = defineEmits(['update:modelValue'])

const isMobile = ref(false)

const update = () => {
  emits('update:modelValue', modelValue.value)
}

const next = () => {
  if (modelValue.value < props.length) {
    modelValue.value += 1
    update()
  }
}

const previous = () => {
  if (modelValue.value > 1) {
    modelValue.value -= 1
    update()
  }
}

onMounted(() => {
  isMobile.value = window.innerWidth < 640
  window.addEventListener("resize", handleWindowResize)
})

onUnmounted(() => {
  window.removeEventListener("resize", handleWindowResize)
})

const handleWindowResize = (e) => {
  isMobile.value = e.target.innerWidth < 640
}

watch(props, (newValue, oldValue) => {
  if (newValue.page) {
    modelValue.value = newValue.page
  }
})
</script>

<style>
.v-pagination__list {
  position: relative;
  align-items: center;
}

.v-pagination__prev {
  position: absolute;
  left: 0px;
}

.v-pagination__next {
  position: absolute;
  right: 0px;
}

.v-pagination .v-btn {
  border-radius: 8px;
}
</style>